package com.enitsys.sqltools;

import javax.crypto.BadPaddingException;
import javax.crypto.Cipher;
import javax.crypto.IllegalBlockSizeException;
import java.io.IOException;
import java.nio.charset.StandardCharsets;
import java.sql.SQLException;
import java.util.Base64;

public final class Encrypt extends AbstractTool {
    private final String password;
    public Encrypt(String taskname, String password, String dummy) throws IOException {
        super(taskname, null, false);
        this.password = password;
    }

    @Override
    public void run() throws SQLException, IOException {

        try {
            String encryptedPassword = Base64.getEncoder().encodeToString(AbstractSQLTool.cipher(Cipher.ENCRYPT_MODE, AbstractSQLTool.getSecret(AbstractSQLTool.getConnectionDir())).doFinal(password.getBytes(StandardCharsets.UTF_8)));
            System.out.println("-----------------------------------------------------------------------------------------------");
            System.out.println("encrypted-password="+encryptedPassword);
            System.out.println("-----------------------------------------------------------------------------------------------");
        } catch (IllegalBlockSizeException e) {
            throw new RuntimeException(e);
        } catch (BadPaddingException e) {
            throw new RuntimeException(e);
        }
    }
    public static void main(String[] args) {
		if (args.length != 1) {
            System.err.println("usage: java [options] "+ Encrypt.class.getName()+" <password>");
            System.exit(1);
        }
        main(Encrypt.class, new String[]{"*",args[0]});
    }

}
