<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE stylesheet [
<!--
  <!ENTITY % w3centities-f PUBLIC "-//W3C//ENTITIES Combined Set//EN//XML"
      "http://www.w3.org/2003/entities/2007/w3centities-f.ent">
  %w3centities-f;
-->
  <!ENTITY nbsp             "&#x000A0;" >
  <!ENTITY copy             "&#x000A9;" >
]>

<xsl:stylesheet version="2.0"
    xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
    xmlns:xs="http://www.w3.org/2001/XMLSchema"
    xmlns:svg="http://www.w3.org/2000/svg"
    xmlns:dbmeta="urn:enitsys.com:xsd:db-metadata:1.0"
    xmlns:dbmeta2html="urn:enitsys:xsd:dbmeta2html:functions:1.0"
    
	>
<xsl:character-map name="html-entities">
<!-- 
    <xsl:output-character character="&#x82;" string="'"/>
    <xsl:output-character character="&#x84;" string="&quot;"/>
    <xsl:output-character character="&#x85;" string="..."/>
    <xsl:output-character character="&#x91;" string="'"/>
    <xsl:output-character character="&#x92;" string="'"/>
    <xsl:output-character character="&#x93;" string="&quot;"/>
    <xsl:output-character character="&#x94;" string="&quot;"/>
    <xsl:output-character character="&#x95;" string="*"/>
    <xsl:output-character character="&#x96;" string="-"/>
-->    

    <xsl:output-character character="&#x82;" string="&#x201A;"/>
    <xsl:output-character character="&#x84;" string="&#x201E;"/>
    <xsl:output-character character="&#x85;" string="&#x2026;"/>
    <xsl:output-character character="&#x91;" string="&#x2018;"/>
    <xsl:output-character character="&#x92;" string="&#x2019;"/>
    <xsl:output-character character="&#x93;" string="&#x201C;"/>
    <xsl:output-character character="&#x94;" string="&#x201D;"/>
    <xsl:output-character character="&#x95;" string="&#x2022;"/>
    <xsl:output-character character="&#x96;" string="&#x2013;"/>

<!-- 
    <xsl:output-character character="&#x82;" string="&sbquo;"/>
    <xsl:output-character character="&#x84;" string="&bdquo;"/>
    <xsl:output-character character="&#x85;" string="&hellip;"/>
    <xsl:output-character character="&#x91;" string="&lsquo;"/>
    <xsl:output-character character="&#x92;" string="&rsquo;"/>
    <xsl:output-character character="&#x93;" string="&ldquo;"/>
    <xsl:output-character character="&#x94;" string="&rdquo;"/>
    <xsl:output-character character="&#x95;" string="&bull;"/>
    <xsl:output-character character="&#x96;" string="&ndash;"/>
 -->    
</xsl:character-map>
 
 
<xsl:variable name="db" as="node()" select="//dbmeta:database"/>
<xsl:variable name="doctitle" as="xs:string" select="$db/@dbmeta:db-label"/>

<xsl:output method="html" version="5" html-version="5.0" encoding="UTF-8" omit-xml-declaration="no" standalone="yes" indent="yes" use-character-maps="html-entities" />

  <xsl:function name="dbmeta2html:obj-type" as="xs:string">
  <xsl:param name="obj" as="node()"/>
  <xsl:choose>
  	<xsl:when test="$obj/@dbmeta:object-type = 'TABLE'"><xsl:value-of select="'Table'"/></xsl:when>
  	<xsl:when test="$obj/@dbmeta:object-type = 'VIEW'"><xsl:value-of select="'View'"/></xsl:when>
  	<xsl:when test="$obj/@dbmeta:object-type = 'ENTITY'"><xsl:value-of select="'Entity'"/></xsl:when>
  	<xsl:when test="$obj/@dbmeta:object-type = 'MODEL'"><xsl:value-of select="'Model'"/></xsl:when>
  	<xsl:when test="$obj/@dbmeta:object-type = 'PACKAGE'"><xsl:value-of select="'Package'"/></xsl:when>
  	<xsl:when test="$obj/@dbmeta:object-type = 'PACKAGE BODY'"><xsl:value-of select="'PackageBody'"/></xsl:when>
  	<xsl:when test="$obj/@dbmeta:object-type = 'TYPE'"><xsl:value-of select="'Type'"/></xsl:when>
  	<xsl:otherwise><xsl:value-of select="concat('Unknown Objecttype ',$obj/@dbmeta:object-type)"/></xsl:otherwise>
  	</xsl:choose>
  </xsl:function>

  <xsl:function name="dbmeta2html:obj-name" as="xs:string">
  <xsl:param name="obj" as="node()"/>
  <xsl:choose>
  	<xsl:when test="$obj/@dbmeta:object-type = 'TABLE'"><xsl:value-of select="$obj/@dbmeta:object-name"/></xsl:when>
  	<xsl:when test="$obj/@dbmeta:object-type = 'VIEW'"><xsl:value-of select="$obj/@dbmeta:object-name"/></xsl:when>
  	<xsl:when test="$obj/@dbmeta:object-type = 'PACKAGE'"><xsl:value-of select="$obj/@dbmeta:object-name"/></xsl:when>
  	<xsl:when test="$obj/@dbmeta:object-type = 'PACKAGE BODY'"><xsl:value-of select="$obj/@dbmeta:object-name"/></xsl:when>
  	<xsl:when test="$obj/@dbmeta:object-type = 'TYPE'"><xsl:value-of select="$obj/@dbmeta:object-name"/></xsl:when>
  	<xsl:otherwise><xsl:value-of select="$obj/@dbmeta:object-name"/></xsl:otherwise>
  	</xsl:choose>
  </xsl:function>

        <xsl:function name="dbmeta2html:href" as="xs:string?">
            <xsl:param name="obj" as="node()"/>
            <xsl:param name="reftype" as="xs:string"/>
            <xsl:variable name="object-name" as="xs:string" select="$obj/@dbmeta:object-name"/>
            <xsl:choose>
                <xsl:when test="$reftype = 'overview'">
                    <xsl:choose>
                        <xsl:when test="$obj/@dbmeta:object-type = 'TABLE'"><xsl:value-of select="concat('tables/',$obj/@dbmeta:object-name,'.html')"/></xsl:when>
                        <xsl:when test="$obj/@dbmeta:object-type = 'VIEW'"><xsl:value-of select="concat('views/',$obj/@dbmeta:object-name,'.html')"/></xsl:when>
                        <xsl:when test="$obj/@dbmeta:object-type = 'PACKAGE'"><xsl:value-of select="concat('packages/',$obj/@dbmeta:object-name,'.html')"/></xsl:when>
                        <xsl:when test="$obj/@dbmeta:object-type = 'PACKAGE BODY'"><xsl:value-of select="concat('packages/',$obj/@dbmeta:object-name,'.html')"/></xsl:when>
                        <xsl:when test="$obj/@dbmeta:object-type = 'TYPE'"><xsl:value-of select="concat('types/',$obj/@dbmeta:object-name,'.html')"/></xsl:when>
                    </xsl:choose>
                </xsl:when>
                <xsl:when test="$reftype = 'code'">
                    <xsl:choose>
                        <xsl:when test="$obj/@dbmeta:object-type = 'VIEW' and $obj/dbmeta:code"><xsl:value-of select="concat('viewcode/',$obj/@dbmeta:object-name,'.html')"/></xsl:when>
                        <xsl:when test="$obj/@dbmeta:object-type = 'PACKAGE'"><xsl:value-of select="concat('packagecode/',$obj/@dbmeta:object-name,'.html')"/></xsl:when>
                        <xsl:when test="$obj/@dbmeta:object-type = 'PACKAGE BODY'"><xsl:value-of select="concat('packagecode/',$obj/@dbmeta:object-name,'.html')"/></xsl:when>
                    </xsl:choose>
                </xsl:when>
                <xsl:when test="$reftype = 'bodycode'">
                    <xsl:choose>
                        <xsl:when test="$obj/@dbmeta:object-type = 'PACKAGE' and $db/dbmeta:objects/dbmeta:record[@dbmeta:object-type='PACKAGE BODY' and @dbmeta:object-name = $object-name]"><xsl:value-of select="concat('packagebody/',$obj/@dbmeta:object-name,'.html')"/></xsl:when>
                        <xsl:when test="$obj/@dbmeta:object-type = 'PACKAGE BODY'"><xsl:value-of select="concat('packagebody/',$obj/@dbmeta:object-name,'.html')"/></xsl:when>
                    </xsl:choose>
                </xsl:when>
            </xsl:choose>
        </xsl:function>

  <xsl:function name="dbmeta2html:obj-label" as="xs:string">
  <xsl:param name="obj" as="node()"/>
  <xsl:value-of select="concat(dbmeta2html:obj-type($obj),' ',dbmeta2html:obj-name($obj))"/>
  </xsl:function>

  <xsl:function name="dbmeta2html:ref-desc" as="xs:string">
  <xsl:param name="ref" as="node()"/>
    <xsl:choose>
  	<xsl:when test="$ref/@dbmeta:dependency-type='CodeReference'">[Code Reference]</xsl:when>
  	<xsl:when test="$ref/@dbmeta:dependency-type='ForeignKey'"><xsl:value-of select="concat('[Foreign Key from (',$ref/@dbmeta:object-columns,') to (',$ref/@dbmeta:src-columns,')]')"/></xsl:when>
  	</xsl:choose>

  </xsl:function>
  
  <xsl:template name="obj-href">
  	<xsl:param name="root" as="xs:string"/>
  	<xsl:param name="obj" as="node()"/>
  	<xsl:variable name="type" as="xs:string" select="$obj/@dbmeta:object-type"/>
  	<a href="{concat($root,dbmeta2html:href($obj,'overview'))}"><xsl:value-of select="dbmeta2html:obj-label($obj)"/></a>
  </xsl:template>

  <xsl:template name="href">
  	<xsl:param name="root" as="xs:string"/>
  	<xsl:param name="type" as="xs:string"/>
  	<xsl:param name="object" as="xs:string"/>
  	
  	
  	<xsl:variable name="obj" as="node()?"><xsl:sequence select="$db/dbmeta:objects/dbmeta:record[@dbmeta:object-type = $type and @dbmeta:object-name = $object]"/>
  	</xsl:variable>
      <p class="{concat($type,' ',$object)}"></p>
  	<xsl:choose>
  	<xsl:when test="$obj"><xsl:call-template name="obj-href"><xsl:with-param name="root" select="$root"/><xsl:with-param name="obj" as="node()" select="$obj"/></xsl:call-template></xsl:when>
  	<xsl:when test="$type = 'TYPE'"><xsl:sequence select="concat('Type ',$object)"/></xsl:when>
  	<xsl:otherwise><xsl:value-of select="concat('Unknown Objecttype ',$type,' ',$object)"/></xsl:otherwise>
  	</xsl:choose>
  </xsl:template>
  
<!--  <xsl:template name="attr-href">
    <xsl:param name="root" as="xs:string"/>
  	<xsl:param name="attr" as="node()"/>
  	<xsl:variable name="hrefprefix" as="xs:string"><xsl:choose>
  	<xsl:when test="$attr/@dbmeta:attribute-table"><xsl:value-of select="concat(root,'table-',$attr/@dbmeta:attribute-owner,'-',$attr/@dbmeta:attribute-table)"/></xsl:when>
  	<xsl:when test="$attr/@dbmeta:attribute-view"><xsl:value-of select="concat(root,'view-',$attr/@dbmeta:attribute-owner,'-',$attr/@dbmeta:attribute-view)"/></xsl:when>
  	<xsl:otherwise>xxx</xsl:otherwise>
  	</xsl:choose>
  	</xsl:variable>
  	<a href="{concat($hrefprefix,'.html')}"><xsl:value-of select="concat('Attribute ',$attr/@dbmeta:attribute-name,' (',$attr/@dbmeta:attribute-category,')')"/></a>
  </xsl:template>
  -->
  <xsl:template name="head">
    <xsl:param name="root" as="xs:string"/>
    <xsl:param name="title" as="xs:string"/>
    <xsl:param name="prettify" as="xs:boolean?" select="false()"/>
    <head>
		<meta http-equiv="content-type" content="text/html; charset=UTF-8"/> 
		<meta charset="UTF-8" />
		<meta name="viewport" content="width=device-width, initial-scale=1.0"/>
		<title><xsl:value-of select="$title"/></title>
		<meta name="author" content="Rainer Noack"/>
        <link rel="stylesheet" href="{concat($root,'layout.css')}"/>
		<link rel="stylesheet" href="{concat($root,'site.css')}"/>
		<link rel="stylesheet" href="{concat($root,'tooltips.css')}"/>
		<xsl:if test="$prettify">
            <link rel="stylesheet" href="{concat($root,'prettify.css')}"/>
            <script src="{concat($root,'run_prettify.js')}"></script>
            <script src="{concat($root,'lang-sql.js')}"></script>
            <!--
		<script src="https://cdn.jsdelivr.net/gh/google/code-prettify@master/loader/run_prettify.js"></script>
		<script src="{concat($root,'lang-sql.js')}"></script>
		-->
		</xsl:if>
    </head>
  </xsl:template>


  <xsl:template name="header">
    <xsl:param name="root" as="xs:string"/>
    <xsl:param name="this1" as="xs:string?"/>
    <xsl:param name="type" as="xs:string?"/>
    <xsl:param name="name" as="xs:string?"/>
    <xsl:param name="subtitle" as="xs:string?"/>
    <xsl:param name="obj" as="element()?"/>
    <xsl:param name="this2" as="xs:string?"/>
    <div class="header"><header>
    <div class="application"><a style="margin:0px;padding:0px;border-style:none;" href="http://www.enitsys.com">
         <div class="enitsys">enitsys</div>
         <div class="sqltools">SQLTools</div>
         <div class="dbmeta">DB Metadata</div>
         </a></div>
    <div class="content">
    <xsl:call-template name="menu-1"><xsl:with-param name="root" select="$root"/><xsl:with-param name="this" select="$this1"/></xsl:call-template>
    <xsl:call-template name="object-title"><xsl:with-param name="type" select="$type"/><xsl:with-param name="name" select="$name"/><xsl:with-param name="subtitle"  select="$subtitle"/></xsl:call-template>
    <xsl:call-template name="menu-2"><xsl:with-param name="root" select="$root"/><xsl:with-param name="obj" select="$obj"/><xsl:with-param name="this" select="$this2"/></xsl:call-template>
    </div>
    </header></div>
  </xsl:template>

  <xsl:template name="menu-1">
    <xsl:param name="root" as="xs:string"/>
    <xsl:param name="this" as="xs:string?"/>
    <div class="menu1">
    <xsl:choose><xsl:when test="$this = 'Home'"><span class="this">Home</span></xsl:when><xsl:otherwise><span><a href="{concat($root,'index.html')}">Home</a></span></xsl:otherwise></xsl:choose>
    <xsl:choose><xsl:when test="$this = 'Tables'"><span class="this">Tables</span></xsl:when><xsl:otherwise><span><a href="{concat($root,'tables.html')}">Tables</a></span></xsl:otherwise></xsl:choose>
    <xsl:choose><xsl:when test="$this = 'Views'"><span class="this">Views</span></xsl:when><xsl:otherwise><span><a href="{concat($root,'views.html')}">Views</a></span></xsl:otherwise></xsl:choose>
    <xsl:choose><xsl:when test="$this = 'Packages'"><span class="this">Packages</span></xsl:when><xsl:otherwise><span><a href="{concat($root,'packages.html')}">Packages</a></span></xsl:otherwise></xsl:choose>
    </div>
  </xsl:template>

  <xsl:template name="footer">
    <xsl:param name="root" as="xs:string"/>
         <footer>
            <div class="menu">
               <a href="{concat($root, 'lizenz.html')}">Rechtliche Hinweise &amp; Nutzungsbedingungen</a>
  | <a href="{concat($root, 'impressum.html')}">Impressum, Kontakt &amp; Datenschutz</a>
            </div>
            <div class="copy">&copy; Copyright 2023. Alle Rechte vorbehalten.</div>
 </footer>
  </xsl:template>
  
  <xsl:template name="object-title">
    <xsl:param name="type" as="xs:string?"/>
    <xsl:param name="name" as="xs:string?"/>
    <xsl:param name="subtitle" as="xs:string?"/>
    <div class="title"><xsl:value-of select="if($name) then (if ($type) then (concat($type,' ',$name)) else ($name)) else ($doctitle)"/><xsl:value-of select="if($subtitle) then (concat(' - ',$subtitle)) else (' ')"/></div>
  </xsl:template>

  <xsl:template name="menu-2">
    <xsl:param name="root" as="xs:string"/>
    <xsl:param name="obj" as="element()?"/>
    <xsl:param name="this" as="xs:string?"/>
    <xsl:if test="$obj">
    <div class="menu2">
    <xsl:choose><xsl:when test="$this = 'Overview'"><span class="this">Overview</span></xsl:when><xsl:otherwise><span><a href="{concat($root,dbmeta2html:href($obj,'overview'))}">Overview</a></span></xsl:otherwise></xsl:choose>
    <xsl:if test="dbmeta2html:href($obj,'columns')">
    <xsl:choose><xsl:when test="$this = 'Columns'"><span class="this">Columns</span></xsl:when><xsl:otherwise><span><a href="{concat($root,dbmeta2html:href($obj,'columns'))}">Columns</a></span></xsl:otherwise></xsl:choose>
    </xsl:if>
    <xsl:if test="dbmeta2html:href($obj,'code')">
    <xsl:choose><xsl:when test="$this = 'Code'"><span class="this">Code</span></xsl:when><xsl:otherwise><span><a href="{concat($root,dbmeta2html:href($obj,'code'))}">Code</a></span></xsl:otherwise></xsl:choose>
    </xsl:if>
    <xsl:if test="dbmeta2html:href($obj,'bodycode')">
    <xsl:choose><xsl:when test="$this = 'Body'"><span class="this">Body</span></xsl:when><xsl:otherwise><span><a href="{concat($root,dbmeta2html:href($obj,'bodycode'))}">Body</a></span></xsl:otherwise></xsl:choose>
    </xsl:if>
    </div>
    </xsl:if>
  </xsl:template>



  <xsl:template name="list">
    <xsl:param name="root" as="xs:string"/>
	<xsl:param name="obj" as="node()*"/>
	
    <xsl:variable name="cnt" as="xs:decimal" select="ceiling(count($obj) div 6)"/>

    <div class="columns">
    <xsl:for-each select="$obj">
    <div><xsl:call-template name="obj-href"><xsl:with-param name="root" select="$root" /><xsl:with-param name="obj" as="node()" select="." /></xsl:call-template></div>
	</xsl:for-each> 
	</div>
</xsl:template>

  


  <xsl:template match="dbmeta:views/dbmeta:record" mode="doc-code">
    <xsl:variable name="object-name" select="@dbmeta:object-name" />
    <xsl:variable name="root" select="'../'" />
    <xsl:result-document href="{dbmeta2html:href(.,'code')}" method="html" version="5">
    
    <html lang="en">
    <xsl:call-template name="head"><xsl:with-param name="root" select="$root" />
    <xsl:with-param name="title" select="$object-name"/>
    <xsl:with-param name="prettify" as="xs:boolean" select="true()"/></xsl:call-template>
    <body>
    <xsl:call-template name="header"><xsl:with-param name="root" select="$root"/>
    <xsl:with-param name="type">View</xsl:with-param><xsl:with-param name="name" select="$object-name"/><xsl:with-param name="subtitle">Code</xsl:with-param>
    <xsl:with-param name="obj" select="."/><xsl:with-param name="this2">Code</xsl:with-param>
    </xsl:call-template>
    <div class="page"><main>

    <pre class="prettyprint linenums"><code class="language-sql"><xsl:value-of select="dbmeta:code" /></code></pre>
    </main>
    <xsl:call-template name="footer"><xsl:with-param name="root" select="$root"/></xsl:call-template>
    </div></body>
    </html>
    </xsl:result-document>
  </xsl:template>
  

  <xsl:template match="dbmeta:objects/dbmeta:record[@dbmeta:object-type='PACKAGE']" mode="doc-code">
    <xsl:variable name="object-name" select="@dbmeta:object-name" />
    <xsl:variable name="root" select="'../'" />
    <xsl:result-document href="{dbmeta2html:href(.,'code')}" method="html" version="5">
    
    <html lang="en">
    <xsl:call-template name="head"><xsl:with-param name="root" select="$root" /><xsl:with-param name="title" select="$object-name"></xsl:with-param><xsl:with-param name="prettify" as="xs:boolean" select="true()"/></xsl:call-template>
    <body>
    <xsl:call-template name="header"><xsl:with-param name="root" select="$root"/>
    <xsl:with-param name="type">Package</xsl:with-param><xsl:with-param name="name" select="$object-name"/><xsl:with-param name="subtitle">Code (Specification)</xsl:with-param>
    <xsl:with-param name="obj" select="."/><xsl:with-param name="this2">Code</xsl:with-param>
    </xsl:call-template>
    <div class="page"><main>
    <pre class="prettyprint linenums"><code class="language-sql">
        <xsl:for-each select="$db/dbmeta:package-code/dbmeta:record[@dbmeta:object-type = 'PACKAGE' and @dbmeta:object-name = $object-name]">
            <xsl:value-of select="dbmeta:code"/>
        </xsl:for-each>
    </code></pre>
    </main>
    <xsl:call-template name="footer"><xsl:with-param name="root" select="$root"/></xsl:call-template>
    </div></body>
    </html>
    </xsl:result-document>
  </xsl:template>

    <xsl:template match="dbmeta:objects/dbmeta:record[@dbmeta:object-type='PACKAGE BODY']" mode="doc-code">
        <xsl:variable name="object-name" select="@dbmeta:object-name" />
        <xsl:variable name="root" select="'../'" />
        <xsl:result-document href="{dbmeta2html:href(.,'bodycode')}" method="html" version="5">

            <html lang="en">
                <xsl:call-template name="head"><xsl:with-param name="root" select="$root" /><xsl:with-param name="title" select="$object-name"></xsl:with-param><xsl:with-param name="prettify" as="xs:boolean" select="true()"/></xsl:call-template>
                <body>
                    <xsl:call-template name="header"><xsl:with-param name="root" select="$root"/>
                        <xsl:with-param name="type">Package</xsl:with-param><xsl:with-param name="name" select="$object-name"/><xsl:with-param name="subtitle">Body</xsl:with-param>
                        <xsl:with-param name="obj" select="."/><xsl:with-param name="this2">Body</xsl:with-param>
                    </xsl:call-template>
                    <div class="page"><main>
                        <pre class="prettyprint linenums"><code class="language-sql">
                            <xsl:for-each select="$db/dbmeta:package-code/dbmeta:record[@dbmeta:object-type = 'PACKAGE BODY' and @dbmeta:object-name = $object-name]">
                                <xsl:value-of select="dbmeta:code"/>
                            </xsl:for-each>
                        </code></pre>
                    </main>
                        <xsl:call-template name="footer"><xsl:with-param name="root" select="$root"/></xsl:call-template>
                    </div></body>
            </html>
        </xsl:result-document>
    </xsl:template>

  <xsl:template match="dbmeta:tables/dbmeta:record" mode="doc-overview">
    <xsl:variable name="object-name" select="@dbmeta:object-name"/>
    <xsl:variable name="partitioning-model" select="@dbmeta:partitioning-model"/>
    <xsl:variable name="table-category" select="@dbmeta:table-category"/>
    <xsl:variable name="root" select="'../'"/>
    <xsl:result-document href="{dbmeta2html:href(.,'overview')}" method="html" version="5">
    <html lang="en">
    <xsl:call-template name="head"><xsl:with-param name="root" select="$root"/><xsl:with-param name="title" select="$object-name"></xsl:with-param></xsl:call-template>
    <body>
    <xsl:call-template name="header"><xsl:with-param name="root" select="$root"/>
    <xsl:with-param name="type">Table</xsl:with-param><xsl:with-param name="name" select="$object-name"/>
    <xsl:with-param name="obj" select="."/><xsl:with-param name="this2">Overview</xsl:with-param>
    </xsl:call-template>
    <div class="page"><main>
    <xsl:if test="dbmeta:description">
    <h2>Description</h2>
    <p><xsl:value-of select="dbmeta:description"/></p>
    </xsl:if>
    <h2>Properties</h2>
    <div class="property"><div class="property name">Tablespace:</div><xsl:value-of select="if (@dbmeta:tablespace-name) then (@dbmeta:tablespace-name) else ($db//dbmeta:table-data[@dbmeta:table-name = 'T_MAP_TABLE']/dbmeta:record[@dbmeta:table-name = $object-name]/@dbmeta:table-tablespace)"/></div>
        <h2>Columns</h2>
        <table class="table columns">
            <tr><xsl:for-each select="$db/dbmeta:indexes/dbmeta:record[@dbmeta:object-name = $object-name]"><th class="index"><xsl:choose>
                <xsl:when test="@dbmeta:constraint-type = 'P'">PK</xsl:when>
                <xsl:when test="@dbmeta:index-type = 'BITMAP'">BX</xsl:when>
                <xsl:when test="@dbmeta:uniqueness = 'UNIQUE'">UX</xsl:when>
                <xsl:otherwise>IX</xsl:otherwise>
            </xsl:choose></th></xsl:for-each>
                <th class="name">Column Name</th><th class="type">Datatype</th><th class="nulls">Nulls</th><th class="description">Description</th></tr>
            <xsl:for-each select="$db/dbmeta:table-columns/dbmeta:record[@dbmeta:object-name = $object-name]">
                <xsl:variable name="column-name" select="@dbmeta:column-name"/>
                <tr>
                    <xsl:for-each select="$db/dbmeta:indexes/dbmeta:record[@dbmeta:object-name = $object-name]">
                        <xsl:variable name="index-name" select="@dbmeta:index-name"/>
                        <td class="index"><xsl:value-of select="//dbmeta:index-columns/dbmeta:record[@dbmeta:object-name = $object-name and @dbmeta:index-name = $index-name and @dbmeta:column-name = $column-name]/@dbmeta:column-position"/></td>
                    </xsl:for-each>
                    <td class="name"><xsl:value-of select="@dbmeta:column-name"/></td>
                    <td class="type"><xsl:value-of select="@dbmeta:data-type"/></td>
                    <td class="nulls"><xsl:value-of select="@dbmeta:nullable"/></td>
                    <td class="description"><xsl:value-of select="dbmeta:description"/></td>
                </tr>
            </xsl:for-each>
        </table>

   <xsl:if test="$db/dbmeta:object-dependencies/dbmeta:record[@dbmeta:object-type = 'TABLE' and @dbmeta:object-name = $object-name]">
    <h2>References</h2>
    <p>
    <xsl:for-each select="$db/dbmeta:object-dependencies/dbmeta:record[@dbmeta:object-type = 'TABLE' and @dbmeta:object-name = $object-name]">
    <div><xsl:call-template name="href"><xsl:with-param name="root" select="$root"/><xsl:with-param name="type" as="xs:string?" select="@dbmeta:src-type"/><xsl:with-param name="object" as="xs:string?" select="@dbmeta:src-name"/></xsl:call-template>
	<xsl:value-of select="concat(' ',dbmeta2html:ref-desc(.))"/>
	</div>
    </xsl:for-each>
    </p>
    </xsl:if>
    <xsl:if test="$db/dbmeta:object-dependencies/dbmeta:record[@dbmeta:src-type = 'TABLE' and @dbmeta:src-name = $object-name]">
    <h2>Referred by</h2>
    <p>
    <xsl:for-each select="$db/dbmeta:object-dependencies/dbmeta:record[@dbmeta:src-type = 'TABLE' and @dbmeta:src-name = $object-name]">
    <div><xsl:call-template name="href"><xsl:with-param name="root" select="$root"/><xsl:with-param name="type"  as="xs:string?" select="@dbmeta:object-type"/><xsl:with-param name="object" as="xs:string?" select="@dbmeta:object-name"/></xsl:call-template>
	<xsl:value-of select="concat(' ',dbmeta2html:ref-desc(.))"/>
	</div>
    </xsl:for-each>
    </p>
    </xsl:if>
    </main>
    <xsl:call-template name="footer"><xsl:with-param name="root" select="$root"/></xsl:call-template>
    </div></body>
    </html>
    </xsl:result-document>
  </xsl:template>



  <xsl:template match="dbmeta:views/dbmeta:record" mode="doc-overview">
    <xsl:variable name="object-name" select="@dbmeta:object-name"/>
    <xsl:variable name="root" select="'../'"/>
    <xsl:result-document href="{dbmeta2html:href(.,'overview')}" method="html" version="5">
    
    <html lang="en">
    <xsl:call-template name="head"><xsl:with-param name="root" select="$root"/><xsl:with-param name="title" select="$object-name"></xsl:with-param></xsl:call-template>
    <body>
    <xsl:call-template name="header"><xsl:with-param name="root" select="$root"/>
    <xsl:with-param name="type">View</xsl:with-param><xsl:with-param name="name" select="$object-name"/>
    <xsl:with-param name="obj" select="."/><xsl:with-param name="this2">Overview</xsl:with-param>
    </xsl:call-template>
    <div class="page"><main>
    <xsl:if test="dbmeta:description">
    <h2>Description</h2>
    <p><xsl:value-of select="dbmeta:description"/></p>
    </xsl:if>
        <h2>Columns</h2>

        <table class="table columns">
            <tr>
                <th class="name">Column Name</th><th class="type">Datatype</th><th class="nulls">Nulls</th><th class="description">Description</th></tr>
            <xsl:for-each select="$db/dbmeta:view-columns/dbmeta:record[@dbmeta:object-name = $object-name]">
                <xsl:variable name="column-name" select="@dbmeta:column-name"/>
                <tr>
                    <td class="name"><xsl:value-of select="@dbmeta:column-name"/></td>
                    <td class="type"><xsl:value-of select="@dbmeta:data-type"/></td>
                    <td class="nulls"><xsl:value-of select="@dbmeta:nullable"/></td>
                    <td class="description"><xsl:value-of select="dbmeta:description"/></td>
                </tr>
            </xsl:for-each>
        </table>

        <xsl:if test="$db/dbmeta:object-dependencies/dbmeta:record[@dbmeta:object-type = 'VIEW' and @dbmeta:object-name = $object-name]">
            <h2>References</h2>
            <p>
                <xsl:for-each select="$db/dbmeta:object-dependencies/dbmeta:record[@dbmeta:object-type = 'VIEW' and @dbmeta:object-name = $object-name]">
                    <div><xsl:call-template name="href"><xsl:with-param name="root" select="$root"/><xsl:with-param name="type" as="xs:string?" select="@dbmeta:src-type"/><xsl:with-param name="object" as="xs:string?" select="@dbmeta:src-name"/></xsl:call-template>
					<xsl:value-of select="concat(' ',dbmeta2html:ref-desc(.))"/>
					</div>
                </xsl:for-each>
            </p>
        </xsl:if>
        <xsl:if test="$db/dbmeta:object-dependencies/dbmeta:record[@dbmeta:src-type = 'VIEW' and @dbmeta:src-name = $object-name]">
            <h2>Referred by</h2>
            <p>
                <xsl:for-each select="$db/dbmeta:object-dependencies/dbmeta:record[@dbmeta:src-type = 'VIEW' and @dbmeta:src-name = $object-name]">
                    <div><xsl:call-template name="href"><xsl:with-param name="root" select="$root"/><xsl:with-param name="type" as="xs:string?" select="@dbmeta:object-type"/><xsl:with-param name="object" as="xs:string?" select="@dbmeta:object-name"/></xsl:call-template>
					<xsl:value-of select="concat(' ',dbmeta2html:ref-desc(.))"/>
					</div>
                
				</xsl:for-each>
            </p>
        </xsl:if>
    </main>
    <xsl:call-template name="footer"><xsl:with-param name="root" select="$root"/></xsl:call-template>
    </div></body>
    </html>
    </xsl:result-document>
  </xsl:template>

  <xsl:template match="dbmeta:objects/dbmeta:record[@dbmeta:object-type='PACKAGE']" mode="doc-overview">
    <xsl:variable name="object-name" select="@dbmeta:object-name"/>
    <xsl:variable name="root" select="'../'"/>
    <xsl:variable name="body" as="element()?" select="$db/dbmeta:objects/dbmeta:record[@dbmeta:object-type = 'PACKAGE BODY' and @dbmeta:object-name=$object-name]"/>
    <xsl:result-document href="{dbmeta2html:href(.,'overview')}" method="html" version="5">
    
    <html lang="en">
    <xsl:call-template name="head"><xsl:with-param name="root" select="$root"/><xsl:with-param name="title" select="$object-name"></xsl:with-param></xsl:call-template>
    <body>
    <xsl:call-template name="header"><xsl:with-param name="root" select="$root"/>
    <xsl:with-param name="type">Package</xsl:with-param><xsl:with-param name="name" select="$object-name"/>
    <xsl:with-param name="obj" select="."/><xsl:with-param name="this2">Overview</xsl:with-param>
    </xsl:call-template>
    <div class="page"><main>
    <xsl:if test="dbmeta:description">
    <h2>Description</h2>
    <p><xsl:value-of select="dbmeta:description"/></p>
    </xsl:if>
        <xsl:if test="$db/dbmeta:object-dependencies/dbmeta:record[@dbmeta:object-type = 'PACKAGE' and @dbmeta:object-name = $object-name]">
            <h2>Header References</h2>
            <p>
                <xsl:for-each select="$db/dbmeta:object-dependencies/dbmeta:record[@dbmeta:object-type = 'PACKAGE' and @dbmeta:object-name = $object-name]">
                    <div><xsl:call-template name="href"><xsl:with-param name="root" select="$root"/><xsl:with-param name="type" as="xs:string?" select="@dbmeta:src-type"/><xsl:with-param name="object" as="xs:string?" select="@dbmeta:src-name"/></xsl:call-template>
					<xsl:value-of select="concat(' ',dbmeta2html:ref-desc(.))"/>
					</div>
                </xsl:for-each>
            </p>
        </xsl:if>
        <xsl:if test="$db/dbmeta:object-dependencies/dbmeta:record[@dbmeta:object-type = 'PACKAGE BODY' and @dbmeta:object-name = $object-name]">
            <h2>Body References</h2>
            <p>
                <xsl:for-each select="$db/dbmeta:object-dependencies/dbmeta:record[@dbmeta:object-type = 'PACKAGE BODY' and @dbmeta:object-name = $object-name]">
                    <div><xsl:call-template name="href"><xsl:with-param name="root" select="$root"/><xsl:with-param name="type" as="xs:string?" select="@dbmeta:src-type"/><xsl:with-param name="object" as="xs:string?" select="@dbmeta:src-name"/></xsl:call-template>
					<xsl:value-of select="concat(' ',dbmeta2html:ref-desc(.))"/>
					</div>
                </xsl:for-each>
            </p>
        </xsl:if>
        <xsl:if test="$db/dbmeta:object-dependencies/dbmeta:record[@dbmeta:src-type = 'PACKAGE' and @dbmeta:src-name = $object-name]">
            <h2>Referred by</h2>
            <p>
                <xsl:for-each select="$db/dbmeta:object-dependencies/dbmeta:record[@dbmeta:src-type = 'PACKAGE' and @dbmeta:src-name = $object-name]">
                    <div><xsl:call-template name="href"><xsl:with-param name="root" select="$root"/><xsl:with-param name="type" as="xs:string?" select="@dbmeta:object-type"/><xsl:with-param name="object" as="xs:string?" select="@dbmeta:object-name"/></xsl:call-template>
					<xsl:value-of select="concat(' ',dbmeta2html:ref-desc(.))"/>
					</div>
                </xsl:for-each>
            </p>
        </xsl:if>
    </main>
    <xsl:call-template name="footer"><xsl:with-param name="root" select="$root"/></xsl:call-template>
    </div></body>
    </html>
    </xsl:result-document>
  </xsl:template>




<xsl:template match="/" mode="tables">
    <xsl:variable name="root" select="'./'"/>
    <xsl:result-document href="./tables.html" method="html" version="5">
    <html lang="en">
        <xsl:call-template name="head"><xsl:with-param name="root" select="$root"/><xsl:with-param name="title" select="$doctitle"></xsl:with-param></xsl:call-template>
    <body>
    <xsl:call-template name="header"><xsl:with-param name="root" select="$root"/><xsl:with-param name="this1">Tables</xsl:with-param>
    <xsl:with-param name="subtitle">Tables</xsl:with-param>
    </xsl:call-template>
    <div class="page"><main>
    <p>
    <xsl:call-template name="list"><xsl:with-param name="root" select="$root"/><xsl:with-param name="obj" as="node()*" select="$db/dbmeta:tables/dbmeta:record" /></xsl:call-template>
    </p>
    </main>
    <xsl:call-template name="footer"><xsl:with-param name="root" select="$root"/></xsl:call-template>
    </div></body>
    </html>
    </xsl:result-document>
    
  </xsl:template>
  


<xsl:template match="/" mode="views">
    <xsl:variable name="root" select="'./'"/>
    <xsl:result-document href="./views.html" method="html" version="5">
    <html lang="en">
    <xsl:call-template name="head"><xsl:with-param name="root" select="$root"/><xsl:with-param name="title" select="$doctitle"></xsl:with-param></xsl:call-template>
    <body>
    <xsl:call-template name="header"><xsl:with-param name="root" select="$root"/><xsl:with-param name="this1">Views</xsl:with-param>
    <xsl:with-param name="subtitle">Views</xsl:with-param>
    </xsl:call-template>
    <div class="page"><main>
    <p>
    <xsl:call-template name="list"><xsl:with-param name="root" select="$root"/><xsl:with-param name="obj" as="node()*" select="$db/dbmeta:views/dbmeta:record" /></xsl:call-template>
    </p>
    </main>
    <xsl:call-template name="footer"><xsl:with-param name="root" select="$root"/></xsl:call-template>
    </div></body>
    </html>
    </xsl:result-document>
  </xsl:template>

<xsl:template match="/" mode="packages">
    <xsl:variable name="root" select="'./'"/>
    <xsl:result-document href="./packages.html" method="html" version="5">
    <html lang="en">
    <xsl:call-template name="head"><xsl:with-param name="root" select="$root"/><xsl:with-param name="title" select="$doctitle"></xsl:with-param></xsl:call-template>
    <body>
    <xsl:call-template name="header"><xsl:with-param name="root" select="$root"/><xsl:with-param name="this1">Packages</xsl:with-param>
    <xsl:with-param name="subtitle">Packages</xsl:with-param>
    </xsl:call-template>
    <div class="page"><main>
    <p>
    <xsl:call-template name="list"><xsl:with-param name="root" select="$root"/><xsl:with-param name="obj" as="node()*" select="$db/dbmeta:objects/dbmeta:record[@dbmeta:object-type='PACKAGE']" /></xsl:call-template>
    </p>
    </main>
    <xsl:call-template name="footer"><xsl:with-param name="root" select="$root"/></xsl:call-template>
    </div></body>
    </html>
    </xsl:result-document>
  </xsl:template>


  <xsl:template match="/" mode="doc-impressum">
    <xsl:variable name="root" select="'./'"/>
    <xsl:result-document href="impressum.html" method="html" version="5">
    
    <html lang="en">
    <xsl:call-template name="head"><xsl:with-param name="root" select="$root"/><xsl:with-param name="title">Impressum</xsl:with-param></xsl:call-template>
    <body>
    <xsl:call-template name="header"><xsl:with-param name="root" select="$root"/>
    </xsl:call-template>
    <div class="page"><main>
	<p><b>Diese Seite ist ein Platzhalter und NICHT als Impressum oder Datenschutzerklärung für die Veröffentlichung von Inhalten bestimmt, die mit SQLTools erstellt oder generiert wurden.</b></p>
	<p>Für solche Inhalte ist derjenige verantwortlich, der sie veröffentlicht.</p>
	<h2>Begriffsbestimmungen</h2>
	<p><b>SQLTools</b> ist eine Sammlung von Hilfsprogrammen für die Arbeit mit Datenbanken.</p>
	<p>SQLTools ist ein Produkt der <b>enitsys Information Technologies - Rainer Noack</b>. Weitere Informationen finden Sie unter <a href="http://www.enitsys.com" target="_blank">www.enitsys.com</a>.</p>
	<p><b>DB Metadata</b> ist eine Beispielanwendung für die Verwendung der SQLTools. Es handelt sich dabei um eine stark abgespeckte Variante der umfassenden Datenbankdokumentationslösung aus der enitsys-Q Reihe.</p>
    
   </main>
    <xsl:call-template name="footer"><xsl:with-param name="root" select="$root"/></xsl:call-template>
    </div></body>
    </html>
    </xsl:result-document>
  </xsl:template>


  <xsl:template match="/" mode="doc-lizenz">
    <xsl:variable name="root" select="'./'"/>
    <xsl:result-document href="lizenz.html" method="html" version="5">
    
    <html lang="en">
    <xsl:call-template name="head"><xsl:with-param name="root" select="$root"/><xsl:with-param name="title">Impressum</xsl:with-param></xsl:call-template>
    <body>
    <xsl:call-template name="header"><xsl:with-param name="root" select="$root"/>
    </xsl:call-template>
    <div class="page"><main>
	<h2>Rechtliche Hinweise und Nutzungsbedingungen</h2>
	<p>SQLTools werden Ihnen von enitsys kostenlos unter der <a href="http://www.apache.org/licenses/LICENSE-2.0" target="_blank">Apache License, Version 2.0</a> zur Verfügung gestellt.</p>
<p>Diese Lizenz ist als Open Source Lizenz von der OSI (Open Source Initiative) zertifiziert.</p>
<p>Die Software wird auf einer „AS IS“-Basis ohne Garantien oder Gewährleistungen jeglicher Art, weder ausdrücklich noch stillschweigend, zur Verfügung gestellt.</p>
	<p>Eigene Werke, die auf SQLTools basieren, müssen
	<ul><li>eine Kopie der in der Textdatei LICENSE enthaltenen Apache-Lizenz beinhalten,</li>
	<li>bei modifizierten Dateien an auffälliger Stelle angeben, dass sie modifiziert sind,</li>
	<li>in der Quellform alle Original-Urheberrechtsvermerke beibehalten sowie</li>
	<li>die in der Textdatei NOTICE enthaltenen Urhebervermerke auf eine in der Lizenz genauer vorgeschriebene Art und Weise enthalten.</li></ul>
</p>
  	<h2>Haftungsausschluss</h2>
<p>Mit Ausnahme vorsätzlich verursachter Schäden und der Haftung bei Körperschäden haftet der Produktanbieter für keinerlei Schäden die durch die Verwendung des 
Produkts oder die Unmöglichkeit der Verwendung verursacht worden sind. 
Dies gilt ohne Ausnahme auch für entgangenen Geschäftsgewinn, Betriebsunterbrechungen, 
entgangene Geschäftsinformation oder anderen wirtschaftlichen Verlust, auch wenn der Produktanbieter vorher auf die Möglichkeit eines solchen Schadens hingewiesen wurde.
Er haftet insbesondere auch nicht für Verletzungen der Datenschutz- und Geheimhaltungspflichten aus einer Weitergabe oder ungesicherten Aufbewahrung des Produkts.    
</p>

   </main>
    <xsl:call-template name="footer"><xsl:with-param name="root" select="$root"/></xsl:call-template>
    </div></body>
    </html>
    </xsl:result-document>
  </xsl:template>


<xsl:template match="/">
    <xsl:variable name="root" select="'./'"/>
    <html lang="en">
    <xsl:call-template name="head"><xsl:with-param name="root" select="$root"/><xsl:with-param name="title" select="$doctitle"></xsl:with-param></xsl:call-template>
    <body>
    <xsl:call-template name="header"><xsl:with-param name="root" select="$root"/><xsl:with-param name="this1">Home</xsl:with-param>
    </xsl:call-template>
    <div class="page"><main>
<p>	
Dies ist eine Beispielanwendung für die Verwendung von SQLTools.
Über die Links am oberen Rand kann man zu den Metadaten verschiedener Datenbankobjekte navigieren.
</p>
    </main>
    <xsl:call-template name="footer"><xsl:with-param name="root" select="$root"/></xsl:call-template>
    </div></body>
    </html>

<xsl:apply-templates select="." mode="doc-impressum"/>
<xsl:apply-templates select="." mode="doc-lizenz"/>
<xsl:apply-templates select="." mode="tables"/>
<xsl:apply-templates select="$db/dbmeta:tables/dbmeta:record" mode="doc-overview"/>
<xsl:apply-templates select="." mode="views"/>
<xsl:apply-templates select="$db/dbmeta:views/dbmeta:record" mode="doc-overview"/>
<xsl:apply-templates select="$db/dbmeta:views/dbmeta:record" mode="doc-code"/>
<xsl:apply-templates select="." mode="packages"/>
<xsl:apply-templates select="$db/dbmeta:objects/dbmeta:record[@dbmeta:object-type='PACKAGE']" mode="doc-overview"/>
<xsl:apply-templates select="$db/dbmeta:objects/dbmeta:record[@dbmeta:object-type='PACKAGE']" mode="doc-code"/>
<xsl:apply-templates select="$db/dbmeta:objects/dbmeta:record[@dbmeta:object-type='PACKAGE BODY']" mode="doc-code"/>

  </xsl:template>

</xsl:stylesheet>