@setlocal
@chcp 65001 >nul

@echo enitsys SQLTools Beispielprogramm für SQL2xml
@echo:
@echo Dieses Program erzeugt eine xml-Datei mit Meta-Informationen
@echo zu den Datenbankobjekten des Beispielschemas.
@echo Mittels einer kleinen xsl-Datei wird diese xml-Datei dann in eine
@echo einfache html-Schemadokumentation transformiert.
@echo HINWEIS: out.case muss hier auf der Defaulteinstellung für
@echo          Oracle (upper) gesetzt bleiben.
@echo Input (SQL2xml):
@echo   - example/config/sql2xml.dbmeta.Oracle.properties
@echo     - example/config/dbmeta.Oracle.properties
@echo     - example/sql/dbmeta/dbmeta.Oracle.*.sql
@echo Output (SQL2xml):
@echo   - example/out/OracleCS/Example.dbmeta.xml
@echo:
@echo Output (Schemadokumentation):
@echo   - example/out/OracleCS/html/index.html
@echo:

@call %~dp0%_setenv.bat

@set DIR_SQL=%DIR_SQL%dbmeta/

@set DIR_OUT=%DIR_OUT%/OracleCS
@set DIR_TEMP=%DIR_OUT%/temp

@"%JAVA_CMD%" -cp "%CP%" -D"connection.dir=%DIR_CONNECTION%" -D"configuration.dir=%DIR_CONFIG%" -D"sql.dir=%DIR_SQL%" -D"out.dir=%DIR_OUT%" -D"out.tempdir=%DIR_TEMP%" com.enitsys.sqltools.SQL2xml sql2xml.dbmeta.Oracle sqltoolsexample.OracleCS

@set MYSOURCE=%DIR_OUT%/Example.dbmeta.xml
@set DIR_OUT=%DIR_OUT%/html
@set MYOUTFILE=%DIR_OUT%/index.html
@set MYXSL=%DIR_CONFIG%/dbmeta2html.xsl

@echo:
@"%JAVA_CMD%" -cp "%CP%" net.sf.saxon.Transform -s:"%MYSOURCE%" -xsl:"%MYXSL%" -o:"%MYOUTFILE%"

@echo:
@xcopy "%DIR_RESOURCES%\*.*" "%DIR_OUT%\" /I /Q /Y

@echo:
@echo Das Ergebnis findet sich unter
@echo file://%MYOUTFILE%
@echo:
@pause
