with tab_prop as (
select 'TABLE' object_type, table_name object_name, 'PROPERTIES' item_type, x.tablespace_name
     , case when pt.partitioning_type is null then 'NONE' else pt.partitioning_type end partitioning_type
     , pc.column_name part_column
     , pc.data_type part_type
     , case when pc.virtual_column='YES' then pc.data_default else null end part_virtual_function
     , pt.subpartitioning_type
     , spc.column_name subpart_column
     , spc.data_type subpart_type
     , case when spc.virtual_column='YES' then spc.data_default else null end subpart_virtual_function
     , tc.comments
     , '-01-' || table_name || '-01' sorter
    from user_tables x 
    left join user_tab_comments tc using (table_name)
    left join user_part_tables pt using (table_name)
    left join (select x.name table_name, x.column_name, y.data_type, y.virtual_column, y.data_default
            from user_part_key_columns x 
               , user_tab_cols y
           where x.name = y.table_name and x.object_type='TABLE' and y.column_name=x.column_name) pc using(table_name)
    left join (select x.name table_name, x.column_name, y.data_type, y.virtual_column, y.data_default
            from user_subpart_key_columns x 
               , user_tab_cols y
           where x.name = y.table_name and x.object_type='TABLE' and y.column_name=x.column_name) spc  using(table_name)
)
select * from tab_prop
